/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include "undostack.hpp"

namespace nostalgia::studio {

void UndoStack::push(UndoCommand *cmd) noexcept {
	for (const auto i = m_stackIdx; i < m_stack.size();) {
		oxIgnoreError(m_stack.erase(i));
	}
	m_stack.emplace_back(cmd);
	++m_stackIdx;
}

void UndoStack::redo() noexcept {
	m_stack[m_stackIdx++]->redo();
}

void UndoStack::undo() noexcept {
	m_stack[m_stackIdx--]->undo();
}

}