/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <imgui.h>

#include <nostalgia/common/bounds.hpp>

#include "projectexplorer.hpp"

namespace nostalgia {

void ProjectExplorer::draw(core::Context *ctx) noexcept {
	const auto viewport = ImGui::GetMainViewport();
	ImGui::SetNextWindowPos(ImVec2(viewport->Pos.x, viewport->Pos.y + 71));
	ImGui::SetNextWindowSize(ImVec2(313, viewport->Size.y - 71));
	const auto flags = ImGuiWindowFlags_NoTitleBar
	                        | ImGuiWindowFlags_NoResize
	                        | ImGuiWindowFlags_NoMove
	                        | ImGuiWindowFlags_NoScrollbar
	                        | ImGuiWindowFlags_NoSavedSettings;
	ImGui::PushStyleVar(ImGuiStyleVar_WindowBorderSize, 0);
	ImGui::Begin("ProjectExplorer", nullptr, flags);
	ImGui::PopStyleVar();
	ImGui::SetNextTreeNodeOpen(true);
	if (m_treeModel) {
		m_treeModel->draw(ctx);
	}
	ImGui::End();
}

void ProjectExplorer::setModel(ox::UniquePtr<ProjectTreeModel> model) noexcept {
	m_treeModel = std::move(model);
}

}

